<!-- (c) https://github.com/MontiCore/monticore -->

<!DOCTYPE html>
<html lang="en">
	<head>
		<title>MontiSim Visualization</title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
		<link rel="stylesheet" href="css/fontawesome/css/font-awesome.min.css"/>
		<link rel="stylesheet" href="css/main.css"/>
		<link rel="stylesheet" href="css/battery.css" />

        <script src="js/vendor/build/three.js"></script>
		<script src="js/vendor/build/OBJLoader.js"></script>
		<script src="js/vendor/build/MTLLoader.js"></script>

				<script src="js/vendor/build/lib.js"></script>



				<script type="text/javascript" src="js/vendor/build/dat.gui.js"></script>

		<script src="js/vendor/BinaryLoader.js"></script>
		<script src="js/vendor/Detector.js"></script>
		<script src="js/vendor/stats.min.js"></script>
		<script src="js/vendor/Car.js"></script>
		<script src="js/vendor/math.min.js"></script>
		<script src="js/vendor/three.orbitcontrols.js"></script>

        <!--    SFS2X    -->
        <script src="js/vendor/sfs2x-api-1.7.6.js"></script>

        <!-- Dependencies -->
        <script src="js/vendor/Shape.js"></script>
        <script src="js/vendor/ExtrudeGeometry.js"></script>

        <!--    Additions    -->
        <script src="utils/fileHelper/jszip.js"></script>
		<script src="utils/machineLearning/CarDetectionTrainingData.js"></script>
		<script src="//cdn.rawgit.com/Mikhus/canvas-gauges/gh-pages/download/2.1.5/radial/gauge.min.js"></script>



		<!-- Modules -->
		<script src="js/CameraController.js"></script>
		<script src="js/EnvBuilder.js"></script>
		<script src="js/LightController.js"></script>
		<script src="js/RainController.js"></script>
		<script src="js/CarController.js"></script>
		<script src="js/MeshBuilder.js"></script>
		<script src="js/InfoBox.js"></script>
		<script src="js/Zeitleiste.js"></script>
		<script src="js/Gui.js"></script>




        <script src="js/Materials.js"></script>
        <script src="js/CarBuilder.js"></script>

        <script src="js/Server.js"></script>
		<script src="js/WebService.js"></script>
		<script src="js/DataModel.js"></script>
		<script src="js/BatteryIcon.js"></script>
        <!--    HTML components    -->
        <script src="js/NavBar.js"></script>


	</head>

	<body>
        <div id="loader" class="disabled">
            <span>Loading...</span>
        </div>

        <div id="message" class="disabled"></div>

		<!-- <div class="lbl">
			Controls: <br />
			c - change Camera<br />
			u - Orbit Control<br />
			p - Screenshot<br />
			h - toggle HUD<br />
			l - use Stereo
		</div> -->



		<canvas id="hiddenCanvas"></canvas>
		<canvas id="hiddenCanvasLowRes"></canvas>

        <!--    Controls    -->
		<div id="nav-menu"><!-- Dynamic DropDown here --></div>
			
				  <!-- <div id="my-gui-container"></div> -->
					<div id='myInfoBox' class="infoBox">
							<div class="mainBattery">
								<div class='battery'>
									<div class='bottom'></div>
									<div class='middle'>
										<span class='glass'></span>
										<div class='fill'></div>
									</div>
									<div class='top-b'></div>
									<div class='top-a'></div>
								</div>
								<div class='reflection'>
									<div class='fade'></div>
									<div class='bottom'></div>
									<div class='middle'>
										<span class='glass'></span>
										<div class='fill'></div>
									</div>
									<div class='top-b'></div>
									<div class='top-a'></div>
								</div>
						
							</div>
							<span id='battery-value'></span>
						<a href="javascript:void(0)" class='closebtn fa fa-times-circle'  onclick="infoBox.closeInfoBox()"></a>
						<canvas id="gauge" class = "mygauge"></canvas>

					</div>
					<div id="my-gui-container2"></div>


					<!-- <div class="progressbar">
						<div class="value"></div>
					</div> -->

<!-- <div class="progressbar">
					<div class="value"></div>
				</div> -->


        <script>

			if ( ! Detector.webgl ) Detector.addGetWebGLMessage();

			var STATS_ENABLED = false;
			var currentCar = null;
			var heightData;
			var planeX = 4096;
			var planeZ = 4096;
			var planeXVerts = 128;
			var planeZVerts = 128;

			var mapbox = false;
			var eveLis = true;

			var osm2world = false;

			var CARS = {};
			var CARSARR = [];
			let carsError = [];


			var container, stats;

			var camera, hCamera, scene, renderer, rendererH, controls, effect, canvas;

			var m, mi;

			var useStereo = false;
			var dayNightCircle = true;

			var directionalLight;

			var mouseX = 0, mouseY = 0;

			var windowHalfX = window.innerWidth / 2;
			var windowHalfY = window.innerHeight / 2;

			var screenIter = 1;

			var loader = new THREE.BinaryLoader();
			var jsonLoader = new THREE.JSONLoader();
			var tgaLoader = new THREE.TextureLoader();

			var meshArr = [];
			meshArr.trafficLights = [];
			meshArr.pedestrians = [];

			var cameraController = null;
			var carController = new CarController(mapbox);
			var rainController = new RainController();

			var clock = new THREE.Clock();
			var timeDelta = null;

			let screenWidth = window.innerWidth;
			const progressWidth = screenWidth;

			var LS_Meshcounter = 0;
			var LS_Dbg = false;
			var LS_flag = true;

			var infoBoxCreated = false;
			var carNumber = 0;
			var clickedCarId = 1;



			//Create GUI Interface

			gui.createGUI();

			//Create Vehicle Settings folder in GUI Interface

			gui.createVehicleSettings();


			var stereoCameraBaseline = 2;

            var ENV_BUILDER = null;
            var MESH_BUILDER = null;

            var USER = {};

            var INIT_CAR;

            var NUM_MAP_SECTOR = 1;

			init();
			var raycaster = new THREE.Raycaster();
			var mouse = new THREE.Vector2();

			function init() {
				container = document.createElement( 'div' );
				document.body.appendChild( container );

				// CANVAS

				hCanvasLowRes = document.getElementById("hiddenCanvasLowRes");
				hCanvasLowRes.width = 600;
				hCanvasLowRes.height = 300;
				hCanvasLowRes.style.left = "0px";
				hCanvasLowRes.style.top = "0px";
				hCanvasLowRes.style.position = "absolute";
				hCanvasLowRes.style.display = "none";

				hCanvas = document.getElementById("hiddenCanvas");
				hCanvas.width = window.innerWidth;
				hCanvas.height = window.innerHeight;
				hCanvas.style.left = "0px";
				hCanvas.style.top = "0px";
				hCanvas.style.position = "absolute";
				hCanvas.style.display = "none";




				// CAMERAS

				camera = new THREE.PerspectiveCamera( 70, window.innerWidth / window.innerHeight, 100, 15000 );
				camera.projectionMatrix.scale(new THREE.Vector3(-1, 1, 1));
				console.log('camera postion after function '+ camera.position)


				hCamera = new THREE.PerspectiveCamera( 70, window.innerWidth / window.innerHeight, 10, 10000 );




				// ORBIT CONTROL

				controls = new THREE.OrbitControls(camera);
				controls.minDistance = 0;
				controls.maxDistance = Infinity;
				controls.enabled = true;
				controls.target.set(90000, 50, 72000);

				// SCENE



				 window.addEventListener('mousedown', onMouseDown);
				 var temp2;


				 function onMouseDown(event) {
					mouse.x = ( event.clientX / window.innerWidth ) * 2 - 1;
					mouse.y = -( event.clientY / window.innerHeight ) * 2 + 1;

					raycaster.setFromCamera(mouse, camera);

					var intersects = raycaster.intersectObjects([scene], true);
					if (intersects.length > 0  ) {
							var selectedObject = intersects[0].object;
							let selObjID = selectedObject.parent.nameID;

							if(selectedObject.parent.name == 'car'){
								if(temp2 == selectedObject) {
									colorvehicle(temp2,0x000000,1);
									document.getElementById('det').open = false;
									infoBox.closeInfoBox();
									temp2 = null;
								}
								else{
								temp2 = selectedObject;
								colorvehicle(selectedObject,0xff0000,0.2);
								clickedCarId = selObjID
								console.log(clickedCarId);
								infoBox.showInfoBox(clickedCarId);
								document.getElementById('det').open = true;
							}
						}
						else if (selectedObject.parent.name == "Charging_Station") {
						let name = (selectedObject.parent.bname).toString();
						let capacity = selectedObject.parent.capacity.toString();
						let str = "Charging Station name: " + name + " and capacity units: " + capacity;
						alert(str);

					}
					else colorvehicle(temp2,0x000000,1);
				}
				}





				function colorvehicle(carobject,color, intensity){
					if(carobject){
						for(var n =0; n < carobject.material.materials.length; n++){
							carobject.material.materials[n].emissive.setHex( color );
							carobject.material.materials[n].emissiveIntensity = intensity;
						}
					}
				}

				var textureCube = new THREE.CubeTextureLoader()
                //skybox background
					.setPath( 'img/textures/Background/')
					.load( [ 'px.jpg', 'nx.jpg', 'py.jpg', 'ny.jpg', 'pz.jpg', 'nz.jpg' ] );

				scene = new THREE.Scene();

				//Add fog
				scene.fog = new THREE.Fog( 0x808080, 2500, 8000 );
				scene.background = textureCube; //Fog does not work with background!

                var ENV_BUILDER = new EnvBuilder(tgaLoader, scene);
                var MESH_BUILDER = new MeshBuilder(jsonLoader, tgaLoader, scene, meshArr);

				var carBuilder = new CarBuilder(textureCube);

				//attach CameraController
				cameraController = new CameraController(camera);
				cameraController.setCameraPosition(cameraController.DEFAULT_CAMERA);
				cameraController.enableKeyListener();
				cameraController.updateCameraOrigin(90000, 170, 70000);

				rainController.init(scene);

				//draw line between v1 and v2 with color
				function lineDbg(v1, v2, dbgColor) {
					console.log("linedbg fired")
					var mat = new THREE.LineBasicMaterial({color: dbgColor});
					var geometry = new THREE.Geometry();
					geometry.vertices.push( v1, v2 );

					var line = new THREE.Line( geometry, mat );
					scene.add( line );
				}

				//place sign at corresponding position
				function meshHelper(meshBuilder, node, prev) {
					var meshType = node.streetSign.type;
					var id = node.streetSign.id;
					var angle = 0;
					if(typeof prev != 'undefined') angle = -(Math.atan2(node.z - prev.z, node.x - prev.x) + 3/2*math.pi);
					switch(meshType) {
						case "EMPTY_SIGN":
							break;
						case "TRAFFIC_LIGHT":
							if(node.streetSign.one) meshBuilder.addTrafficLight( id, {x: node.streetSign.x1, y:0 , z: node.streetSign.z1}, {x:0, y:angle + math.pi, z:0} );
							if(node.streetSign.two) meshBuilder.addTrafficLight( id, {x: node.streetSign.x2, y:0 , z: node.streetSign.z2}, {x:0, y:angle, z:0} );
							break;
						case "EGG_SIGN":
							if(node.streetSign.one) meshBuilder.addEggSign( id, {x: node.streetSign.x1, y:0 , z: node.streetSign.z1}, {x:0, y:angle, z:0} );
							if(node.streetSign.two) meshBuilder.addEggSign( id, {x: node.streetSign.x2, y:0 , z: node.streetSign.z2}, {x:0, y:angle + math.pi, z:0} );
							break;
						case "INTERSECTION_SIGN":
							if(node.streetSign.one) meshBuilder.addIntersectionSign( id, {x: node.streetSign.x1, y:0 , z: node.streetSign.z1}, {x:0, y:angle, z:0} );
							if(node.streetSign.two) meshBuilder.addIntersectionSign( id, {x: node.streetSign.x2, y:0 , z: node.streetSign.z2}, {x:0, y:angle + math.pi, z:0} );
							break;
						case "STOP_SIGN":
							if(node.streetSign.one) meshBuilder.addStopSign( id, {x: node.streetSign.x1, y:0 , z: node.streetSign.z1}, {x:0, y:angle, z:0} );
							if(node.streetSign.two) meshBuilder.addStopSign( id, {x: node.streetSign.x2, y:0 , z: node.streetSign.z2}, {x:0, y:angle + math.pi, z:0} );
							break;
						case "PRIORITY_SIGN":
							if(node.streetSign.one) meshBuilder.addPrioritySign( id, {x: node.streetSign.x1, y:0 , z: node.streetSign.z1}, {x:0, y:angle, z:0} );
							if(node.streetSign.two) meshBuilder.addPrioritySign( id, {x: node.streetSign.x2, y:0 , z: node.streetSign.z2}, {x:0, y:angle + math.pi, z:0} );
							break;
						default:
							meshBuilder.addDummy( -2, {x: node.x, y: node.y, z: node.z}, {x:0, y:angle + math.pi, z:0} );
							break;
					}
					//show nodes and connections
					if(LS_Dbg) {
						if(node.streetSign.one) lineDbg({x: node.x, y: 40, z: node.z}, {x: node.streetSign.x1, y:40 , z: node.streetSign.z1}, 0xcc5c00);
						if(node.streetSign.two) lineDbg({x: node.x, y: 40, z: node.z}, {x: node.streetSign.x2, y:40 , z: node.streetSign.z2}, 0x0000ff);
						meshBuilder.addDummy( -2, {x: node.x, y: node.y, z: node.z}, {x:0, y:angle, z:0} );
					}

				}

				//ATTACH DATA HANDLERS
				//environment


				DataModel.addHandler(DataModel.STREETS_HANDLER, function streetsHandler(data, resolve, reject) {
										console.log(data);
									  //clear environment before building up the new one.
                    //It is IMPORTANT, that this handler is executed before any other (first added in DataModel handlers), otherwise the new environment might not be build completely
                    ENV_BUILDER.clear();
                    MESH_BUILDER.clear();
                    INIT_CAR = null; //reset followed car
                    //remove previous cars
                    for(var c in CARS) {
                        scene.remove(CARS[c].object);
                        carController.removeCar(c,mapbox); //remove car from CarController
                    }
                    CARS = {}; //reset car list

					var prevNode;
					for(var i=0; i<data.length; ++i) {
						//nodes for streets and signs
						for(var n=0; n<data[i].nodes.length; ++n) {
							var node = data[i].nodes[n];
							if(LS_Meshcounter < 200) {
								meshHelper(MESH_BUILDER, node, prevNode);
							}
							prevNode = {x: node.x, z: node.z};

							data[i].nodes[n] = new THREE.Vector3(node.x, node.y, node.z);
						}

						ENV_BUILDER.drawRoad(data[i].nodes, data[i].streetWidth);
					}


          			resolve();
				},mapbox);


				//add chargingstation handler
				DataModel.addHandler(DataModel.CHARGING_STATION_HANDLER, function chargingstatHandler(data, resolve, reject) {
					let cs_pos = {};
					for (let i = 0; i < data.length; ++i) {
						if (data != null) {
							position = { x: data[i].x, y: data[i].y, z: data[i].z };
							id = data[i].id;
							name = data[i].name;
							capacity = data[i].capacity;
							MESH_BUILDER.addCharging(i, position, name, capacity);

						}
					}
					resolve();
				}, mapbox);


				//map bounds (terrain)
				DataModel.addHandler(DataModel.BOUNDS_HANDLER, function terrainHandler(data, resolve, reject) {
					console.log(data);
					ENV_BUILDER.addTerrain(data);
					resolve();

				},mapbox);

				DataModel.addHandler(DataModel.BUILDINGS_HANDLER, function buildingsHandler(data, resolve, reject) {
					var distance;
					var prevNode  = {x:0,z:0};
					for(var i=0; i<data.length; ++i) {
						for(var n=0; n<data[i].nodes.length; ++n) {
							var node = data[i].nodes[n];
							distance = {x:(node.x - prevNode.x), z:(node.z - prevNode.z)}
							prevNode = {x: node.x, z: node.z};

							data[i].nodes[n] = new THREE.Vector3(node.x, node.y, node.z);


						}
						if(data != null){

							MESH_BUILDER.addBuilding(i , data[i].nodes);
						}
					}

						console.log(data);
								resolve();
				},mapbox);


				DataModel.addHandler(DataModel.RIVER_HANDLER, function riversHandler(data, resolve, reject) {
					console.log(data);

					var prevNode;
					for(var i=0; i<data.length; ++i) {
						//nodes for streets and signs
						for(var n=0; n<data[i].nodes.length; ++n) {
							var node = data[i].nodes[n];
							if(LS_Meshcounter < 200) {
								meshHelper(MESH_BUILDER, node, prevNode);
							}
							prevNode = {x: node.x, z: node.z};

							data[i].nodes[n] = new THREE.Vector3(node.x, node.y, node.z);
						}

						ENV_BUILDER.drawRiver(data[i].nodes, 600);
					}


								console.log(data);
								resolve();
				},mapbox);



				//cars
				DataModel.addHandler(DataModel.CARS_HANDLER, function carsHandler(data, resolve, reject) {
                    var isCarListChanged = false;

                    var remainingCars = [];

					for(var i=0; i<data.length; ++i) {
                        var carExists = false;
                        //check if the car already exists
                        for(var c in CARS) {
                            if(carExists = (CARS[c].id === data[i].id)) break;
                        }

                        if(carExists) {
							carController.handleData(data[i], resolve, mapbox);
							updateBattery(data);
                        }else {
                            //fixed car type and material
														carNumber++;
                            data[i].type = gui.options.model;
														var x = parseInt(gui.options.color);
														if(gui.options.Metal && !(5<x<10)){x = x+10};
							data[i].material = x;
							console.log(data[i].position)
                            CARS[data[i].id] = carBuilder.build(data[i].id, data[i].type, data[i].material, data[i].position, scene); //data .type and .material are currently undefined, so we get random values

                            isCarListChanged = true;
                            //add car
                            carController.addCar(data[i].id, CARS[data[i].id]);
																//lineDbg({x:16607.17910259294, y:0, z:16778.49875997056}, {x: 19607.17910259294, y:0 , z:18778.49875997056},0xffffff);
                            window.setTimeout(resolve, 2000); //Some time to display the car
                        }

                        //keep track of remaining cars
                        remainingCars.push("" + data[i].id);
					}

                    if(remainingCars.length > 0) { //remove cars, only if there is at least one left to allow animation
                        //find missing cars
                        var toBeRemoved = [];
                        for(var c in CARS)
                            if(remainingCars.indexOf(c) < 0) toBeRemoved.push(c);

                        //remove missing cars
                        for(var i=0; i<toBeRemoved.length; ++i) {
                            scene.remove(CARS[toBeRemoved[i]].object);
                            carController.removeCar(toBeRemoved[i]);
                            delete CARS[toBeRemoved[i]];
                        }
                        //update car list in nav bar
                        if(toBeRemoved.length > 0) isCarListChanged = true;
                    }

                    let userVar = 1; // USER.getVariable("vehicle_id");
                    //set init car, when we have not done this before, there is a user variable for the car and the car has already been initialized (displayed)
                    if(!INIT_CAR && userVar && (CARS.hasOwnProperty(userVar.value))) {
                        INIT_CAR = userVar.value;
                        switchCar(INIT_CAR);
                    }else if(!currentCar && data.length > 0) switchCar(data[0].id);

                    //update buttons
                    if(isCarListChanged) lib.initCarButtons();
				},mapbox);

				//rain
				DataModel.addHandler(DataModel.RAIN_HANDLER, function rainHandler(data, resolve, reject) {
					if(typeof carController.getCurrentCarObj() !== 'undefined') {
						var carPos = carController.getCurrentCarObj().model.root.position;
					}

					if(data) {
						rainController.startRaining(scene, carPos);
					} else {
						rainController.stopRaining(scene);
					}
					resolve();
				},mapbox);

				//pedestrians
				DataModel.addHandler(DataModel.PEDESTRIANS_HANDLER, function pedestriansHandler(data, resolve, reject) {
					for(var i = 0; i < data.length; ++i) {
                        var pedestrianExists = false;
							for(var p in meshArr.pedestrians)
									if(pedestrianExists = (meshArr.pedestrians[p].projectID == data[i].id)) break;
                        if(pedestrianExists) {
                            // Compute rotation from positions
                            var diffX = (data[i].position.x - meshArr.pedestrians[p].position.x);
                            var diffY = (data[i].position.y - meshArr.pedestrians[p].position.y);
                            var diffZ = (data[i].position.z - meshArr.pedestrians[p].position.z);

                            if (diffX != 0.0 || diffY != 0.0 || diffZ != 0.0)
                            {
                                var diffVector = new THREE.Vector3(diffX, diffY, diffZ);
                                var axisVector = new THREE.Vector3(0.0, 0.0, 1.0);
                                var angle = diffVector.angleTo(axisVector);

                                if (diffX < 0.0) {
                                    angle = -angle;
                                }

                                meshArr.pedestrians[p].rotation.y = angle;
                            }

                            // Update position
                            meshArr.pedestrians[p].position.set( data[i].position.x, data[i].position.y, data[i].position.z );
                        }else {
                            MESH_BUILDER.addArnold(data[i].id, {x: data[i].position.x, y: data[i].position.y, z:data[i].position.z});
                        }
					}

					resolve();
				},mapbox);

                // Static box objects
                DataModel.addHandler(DataModel.STATIC_BOX_OBJECT_HANDLER, function staticBoxObjectsHandler(data, resolve, reject) {
					for(var i = 0; i < data.length; ++i) {
                        // PHYSICAL_OBJECT_TYPE_TREE
                        if (data[i].objectType == 7)
                        {
                            MESH_BUILDER.addTreeStd(data[i].id, {x: data[i].position.x, y: data[i].position.y, z:data[i].position.z}, {x:0, y:0, z:0});
                        }
                        // PHYSICAL_OBJECT_TYPE_STREETLANTERN
                        else if (data[i].objectType == 8)
                        {
                            MESH_BUILDER.addStreetLamp(data[i].id, {x: data[i].position.x, y: data[i].position.y, z:data[i].position.z}, {x:0, y:0, z:0});
                        }
                        //PHYSICAL_OBJECT_TYPE_ROADWORKSIGN
                        else if (data[i].objectType == 9)
                        {
                            MESH_BUILDER.addCons(data[i].id, {x: data[i].position.x, y: data[i].position.y, z:data[i].position.z}, {x:0, y:0, z:0});
                        }
                        //PHYSICAL_OBJECT_TYPE_HOUSE
                        else if(data[i].objectType == 10)
                        {
                        }
                        // PHYSICAL_OBJECT_TYPE_NETWORK_CELL_BASE_STATION
                        else if (data[i].objectType == 11)
                        {
                            var obj = new THREE.Mesh(new THREE.CubeGeometry(data[i].width * 100, data[i].height * 100, data[i].length * 100), new THREE.MeshLambertMaterial({color: 0x555555, side: THREE.DoubleSide}));
                            obj.position.x =16607.17910259294;
                            obj.position.y =0;
                            obj.position.z = data[i].position.z;
                            scene.add(obj);
                        }
                    }
                    resolve();
                },mapbox);

				//execute command after each frame has been rendered
				
                DataModel.afterEachFrame = function doScreenshot() {
					gui.options.frames = Server.nextFrameIdx;
									zeitleiste.updateZeitleiste(eveLis);
									eveLis = false;
								//infoBox.createInfoBox(clickedCarId);
									if(infoBoxCreated)infoBox.updateInfoBox(clickedCarId);

					// Disable sending of screenshots to server for now for WebSocket performance
					// Possibly wrong screenshots anyways?
					/*
					const carId = carController.getCurrentCar();
					const screenshot = getScreenshotAsImg(carId);
					WebService.WS_screenshot({	carId, screenshot });
					*/
				}

                //==========================================================================

                //init NavBar
              //  initNav();
			lib.initNav();


				//==========================================================================





				// LIGHTS

				var ambient = new THREE.AmbientLight( 0xffffff, 2 );
				scene.add( ambient );

				directionalLight = new THREE.DirectionalLight( 0xffffff, 1  );
				directionalLight.position.set(0,1,1).normalize;
				// scene.add( directionalLight );

				hemiLight = new THREE.HemisphereLight( 0xffffff, 0xffffff, 0.2 );
				hemiLight.color.setHSL( 0.6, 0.75, 0.5 );
				hemiLight.groundColor.setHSL( 0.095, 0.5, 0.5 );
				hemiLight.position.set( 0, 500, 0 );
	//		scene.add( hemiLight );

				var spotlight = new THREE.SpotLight(0xffffff,2);
				spotlight.position.copy(camera.position);
				scene.add(spotlight);


				// RENDERER

				renderer = new THREE.WebGLRenderer({ preserveDrawingBuffer: true, antialias: true, alpha: true });
				renderer.setPixelRatio( window.devicePixelRatio );
				renderer.setSize( window.innerWidth, window.innerHeight );
				renderer.setFaceCulling( THREE.CullFaceNone );
				renderer.setClearColor( 0x808080 );

				container.appendChild( renderer.domElement );

				// renderer for normal screenshots
				rendererH = new THREE.WebGLRenderer({preserveDrawingBuffer: true, antialias: true, canvas: hCanvas});
				rendererH.setPixelRatio( window.devicePixelRatio );
				rendererH.setSize( hCanvas.width, hCanvas.height );
				rendererH.setFaceCulling( THREE.CullFaceNone );
				rendererH.setClearColor( 0x808080 );

				container.appendChild( rendererH.domElement );

				// renderer for dashCam screenshots from cars
				rendererHLowRes = new THREE.WebGLRenderer({preserveDrawingBuffer: true, antialias: true, canvas: hCanvasLowRes});
				rendererHLowRes.setPixelRatio( window.devicePixelRatio );
				rendererHLowRes.setSize( hCanvasLowRes.width, hCanvasLowRes.height );
				rendererHLowRes.setFaceCulling( THREE.CullFaceNone );
				rendererHLowRes.setClearColor( 0x808080 );

				container.appendChild( rendererHLowRes.domElement );

				// stereo effect
				effect = new THREE.StereoEffect( renderer );
				effect.setSize( window.innerWidth, window.innerHeight );
				effect.setEyeSeparation(stereoCameraBaseline);

				// stereo effect for hidden LowRes canvas
				effectLowRes = new THREE.StereoEffect( rendererHLowRes );
				effectLowRes.setSize( hCanvasLowRes.width, hCanvasLowRes.height );
				effectLowRes.setEyeSeparation(stereoCameraBaseline);


				if ( STATS_ENABLED ) {

					stats = new Stats();
					container.appendChild( stats.dom );

				}

				document.addEventListener( 'mousemove', onDocumentMouseMove, false );

				window.addEventListener( 'resize', onWindowResize, false );
				document.addEventListener( 'keydown', onKeyDown, false );

			}

   



            //==========================================================================

			/**
			*	toggle some HUD elements
			*/
			function update_datcontrols(){

				gui.createCameraSettings();
				gui.grapicalUI.removeFolder(gui.vehiclesettings);
				gui.createPlaybackSettings();

			}

	//		function handleErrorinProgressbar(frame,error,id, carID){
	// 			if(!(carsError.includes(carID))){
	// 				let framecolor = document.createElement('div');
	// 				let errorwrapper = document.createElement('div');
	// 				let errorinfo = document.createElement('div');
	// 				let erroricon = document.createElement('img');


	// 				let progress = document.getElementById('progress');
	// 				let wrapper = document.getElementById('progWrapper');

	// 				let color = 0xff0000;
	// 				let counter = 1;
	// 				let car = {};
	// 				for(let c in CARS){
	// 					if(c == carID) {

	// 						switch(error){
	// 							case 0: CARS[c].errorflags = [[true,frame],[false,0]];
	// 													break;
	// 							case 1:	CARS[c].errorflags = [[false,0],[true,frame]];
	// 													break;
	// 							default: break;
	// 						}


	// 						car = c;
	// 						break;
	// 					}
	// 					else{
	// 						counter++;
	// 					}
	// 				}
	// 				errorwrapper.appendChild(erroricon);
	// 				errorwrapper.appendChild(errorinfo);

	// 				wrapper.appendChild(errorwrapper);
	// 				progress.appendChild(framecolor);


	// 				switch(error){
	// 					case 0: 	framecolor.classList.add('crash');
	// 											erroricon.src = 'img/crash.png';
	// 											errorinfo.innerHTML = 'Car '+counter+ '  <br> crashed at Frame:'+frame;
	// 											break;
	// 					case 1:	framecolor.classList.add('leftStreet');
	// 											erroricon.src = 'img/leftroad.png';
	// 											errorinfo.innerHTML = 'Car '+counter+ ' <br> left Street at Frame:'+frame;

	// 											break;
	// 					default: break;
	// 				}


	// 			let width = (frame*screenWidth)/gui.options.lf;
	// 			let iconID = 'icon' + id, infoID = 'info' +id ;
	// 			erroricon.id =  iconID;
	// 			errorinfo.id = infoID;


	// 			erroricon.addEventListener('mouseover',function(e){
	// 				show(e.target.param);
	// 			},false);
	// 			erroricon.addEventListener('mouseout',function(e) {
	// 				hide(e.target.param);
	// 			},false);

	// 			erroricon.addEventListener('mousedown',function(e){
	// 				jumptoframe(e.target.frame);
	// 				switchcar(car);
	// 			},false);


	// 			erroricon.param = id;
	// 			erroricon.frame = frame;


	// 			erroricon.classList.add('icon');
	// 			errorinfo.classList.add('errInfo');

	// 			errorwrapper.classList.add('errorwrapper')
	// 			framecolor.style.left = width + 'px';
	// 			errorwrapper.style.left = width + 'px';
    //   }

	// 			carsError.push(carID);

	//		}
			function show(id)
			{
				document.getElementById('info'+id).style.visibility = 'visible'
			}
			function hide(id)
			{
				document.getElementById('info'+id).style.visibility = 'hidden'
			}
			function jumptoframe(frame){
				WebService.WS_rewind(frame-3);
				WebService.WS_nextFrame();
				WebService.WS_nextFrame();
				WebService.WS_pause();

			}

			function toggleHUD() {
				var HUD = ["nav-menu"];

				for(var i = 0; i<HUD.length; i++) {
					var display = document.getElementById(HUD[i]).style.display;
					if(display != "none") document.getElementById(HUD[i]).style.display="none";
					else document.getElementById(HUD[i]).style.display="block";
				}
			}

			/**
			*	move camera to position
			*	@param {int} x the x-coordinate to be set
			*	@param {int} y the y-coordinate to be set
			*	@param {int} z the z-coordinate to be set
			*/
			function goTo(x,y,z){
				camera.position.x = x;
				camera.position.y = y;
				camera.position.z = z;
			}

			/**
			*	set time
			*	@param {string} time day, night or circle to start/stop cycle
			*/
			function setTime(time) {
				switch(time) {
					case 'circle':
						dayNightCircle = true;
						directionalLight.visible = true;
						break;
					case 'day':
						dayNightCircle = false;
						directionalLight.visible = true;
						directionalLight.position.set(0,1,0).normalize;
						return "Praise the Sun!";
					case 'night':
						dayNightCircle = false;
						directionalLight.visible = false;
						return "Goodnight";
				}
			}

			function getHeightData(img,scale) {

				 if (scale == undefined) scale=1;

					var canvas = document.createElement( 'canvas' );
					canvas.width = img.width;
					canvas.height = img.height;
					var context = canvas.getContext( '2d' );

					var size = img.width * img.height;
					var data = new Float32Array( size );

					context.drawImage(img,0,0);

					for ( var i = 0; i < size; i ++ ) {
						data[i] = 0
					}

					var imgd = context.getImageData(0, 0, img.width, img.height);
					var pix = imgd.data;

					var j=0;
					for (var i = 0; i<pix.length; i +=4) {
						var all = pix[i]+pix[i+1]+pix[i+2];
						data[j++] = all*scale;
				}

				return data;
			}

			function getHeightForPosition(x,z)
			{
				var xnew = planeXVerts/planeX*x;
				var znew = planeZVerts/planeZ*z;


				var xnewf = math.floor(xnew);
				var znewf = math.floor(znew);
				/*
				var xnewc = math.ceil(xnew);
				var znewc =  math.ceil(znew);

				xnewc = (xnewc % planeXVerts == 0) ? xnewf : xnewc;
				znewc = (znewc % planeZVerts == 0) ? znewf : znewc;

				console.log(xnew);
				console.log(znew);
				var X = math.matrix([[xnewf, znewf, 1], [xnewf, znewc, 1],[xnewc, znewf, 1],[xnewc, znewc, 1]]);
				console.log(X);
				var r = math.matrix([[heightData[xnewf*planeZVerts+znewf]],[heightData[xnewf*planeZVerts+znewc]],[heightData[xnewc*planeZVerts+znewf]],[heightData[xnewc*planeZVerts+znewc]]]);
				console.log(r);
				var a= math.multiply(math.multiply(math.inv(math.multiply(math.transpose(X),X)),math.transpose(X)),r);
				height = math.multiply(math.transpose(a), math.matrix([[xnew], [znew],[1]]));
				return height;
				*/
				return heightData[xnewf+planeXVerts*znewf];
			}
			function onWindowResize() {

				windowHalfX = window.innerWidth / 2;
				windowHalfY = window.innerHeight / 2;

				camera.aspect = window.innerWidth / window.innerHeight;
				camera.updateProjectionMatrix();
				camera.projectionMatrix.scale(new THREE.Vector3(-1, 1, 1));

				hCamera.aspect = window.innerWidth / window.innerHeight;
				hCamera.updateProjectionMatrix();

				renderer.setSize( window.innerWidth, window.innerHeight );
				rendererH.setSize( window.innerWidth, window.innerHeight );

				effect.setSize( window.innerWidth, window.innerHeight );
			}

			/**
			*	save/download uri(screenshot) through browser
			*	(important to set preserveDrawingBuffer: true when initializing WebGLRenderer)
			*	@param {string} uri base64 string containing the screenshot
			*	@param {string} filename name the file gets
			*/
			function saveAsJPG(uri, filename) {
				  var link = document.createElement('a');
				  if (typeof link.download === 'string') {
					link.href = uri;
					link.download = filename;

					//Firefox requires the link to be in the body
					document.body.appendChild(link);

					//simulate click
					link.click();

					//remove the link when done
					document.body.removeChild(link);
				  } else {
					window.open(uri);
				  }
			}

			/**
			*	take screenshot from a given camera as .(type) file
			*	if given a carID returns a lowRes(600x300) stereo screenshot from a dashcam corresponding to carID
			*	(every car has its own THREE.camera)
			*	if stereo effect is enabled returns stereo screenshot from current view(regardless if a different camera is passed)
			*
			*	@param {object/int} cam THREE.Camera/carID
			*	@param {string} type filetype of the image
			*/
			function takeScreenshot( cam, type='image/jpg'){
				var temp = screenIter.toString();
				for(var i = temp.length; i < 3; ++i) temp = "0" + temp;
                // relies on conscientious use of parameter cam
				if(!isNaN(cam)) {
					// cam is carID
					cameraController.updateCarCamera(CARS[cam], hCamera);

					// render picture
					effectLowRes.render( scene, hCamera );

					saveAsJPG( rendererHLowRes.domElement.toDataURL(type) , currentCar + "_" + temp + ".jpg" );
				} else {
					// cam is camera
					if (useStereo) {
						// render picture
						effect.render( scene, camera );
						saveAsJPG( renderer.domElement.toDataURL(type) , currentCar + "_" + temp + ".jpg" );
					} else {
						// render picture
						rendererH.render(scene, cam);
						saveAsJPG( rendererH.domElement.toDataURL(type) , currentCar + "_" + temp + ".jpg" );
					}
				}
				screenIter++;
			}

			/**
			*	returns base64 string of screenshot
			*	see takeScreenshot() for information about functionality
			*/
			function getScreenshotAsImg(cam, type='image/jpg') {
				if(!isNaN(cam)) {
					cameraController.updateCarCamera(CARS[cam], hCamera);
					effectLowRes.render( scene, hCamera );
					return rendererHLowRes.domElement.toDataURL(type);
				} else {
					if (useStereo) {
						effect.render( scene, camera );
						return renderer.domElement.toDataURL(type);
					} else {
						rendererH.render(scene, cam);
						return rendererH.domElement.toDataURL(type);
					}
				}
			}

			function genNegCarTrainingData( num ) {
				generateNegativeTrainingData(num, CARS, controls);
			}

			function $( id ) { return document.getElementById( id ) }
			function button_name( car, index ) { return "m_" + car  + "_" + index }

			function switchCar( car ) {
				console.log(car);
				console.log(CARS);

				for ( var c in CARS ) {

					if ( c != car && CARS[ c ].root ) {
						//CARS[ c ].object.visible = false;
						CARS[ car ].object.visible = true;
						//CARS[ c ].buttons.style.display = "none";

					}
				}


//				CARS[ car ].buttons.style.display = "block";

//				$( "car_name" ).innerHTML = CARS[ car ].name + " model";
//				$( "car_author" ).innerHTML = CARS[ car ].author;

				currentCar = car;
                carController.setCurrentCar(currentCar);

			}


			function onDocumentMouseMove(event) {

				mouseY = ( event.clientY - window.innerHeight );

			}

			function onKeyDown ( event ) {
				switch ( event.keyCode ) {
					case 80: // p
						takeScreenshot(camera);
						break;
					case 76: // l
						useStereo = !useStereo;
						onWindowResize();
						break;
					case 72: // h
						toggleHUD();
						break;
					case 85: // u
						controls.enabled = !controls.enabled;
						break;
				}
			}
			//

			function animate() {
				let speed;

                if (DataModel.simulationTimeDeltaMs > 0) {

									if(!gui.options.manualPlayback) {
										setTimeout(function() {requestAnimationFrame(animate);}, DataModel.simulationTimeDeltaMs);
									}
									else{
										// convert scale [0,1] to scale [1,200] with 1 being user value for fast speed playblack and 0 being slow playbackSpeed
										// so 0 = 200 and 1 = 1
										speed = (gui.options.playbackSpeed * (-199)) + 200;
									  setTimeout(function() {requestAnimationFrame(animate);}, speed);
									}


                } else {
                    requestAnimationFrame( animate );

                }


				controls.update();
				render();

			}

			// Rotate an object around an axis in world space (the axis passes through the object's position)

			function render() {
				timeDelta = clock.getDelta();
				var angle = 0.01;
				currentCar = carController.getCurrentCar()
				if(dayNightCircle) {
					if(!isNaN(directionalLight.position.x) && !isNaN(directionalLight.position.z) && !isNaN(angle)) {
						var currentX = directionalLight.position.x;
						var currentY = directionalLight.position.y;
						directionalLight.position.x = currentX * Math.cos(angle) - currentY * Math.sin(angle);
						directionalLight.position.y = currentY * Math.cos(angle) + currentX * Math.sin(angle);

						// ** TURN LIGHTS ON BASED ON SUN POSITION **
						currentCarObj = carController.getCurrentCarObj();
						if(typeof currentCarObj !== 'undefined' && currentCarObj.backLight !== null) {
								if(directionalLight.position.y < 0) {
									//Then its dark -> turn on the lights of the current car
									currentCarObj.lightController.turnLightsOn(currentCarObj);
								} else {
									//Then its bright -> turn off the lights of the current car
									currentCarObj.lightController.turnLightsOff(currentCarObj);
								}
						}
					}
				}

				let pos_x = (gui.options.radius* Math.cos(gui.options.cameraAngle));
				let pos_z = (gui.options.radius* Math.sin(gui.options.cameraAngle));

				for (var car in CARS) {
  					if (CARS.hasOwnProperty(car) && CARS[car]!=null) {
					  	// or if (Object.prototype.hasOwnProperty.call(obj,prop)) for safety...
						if(car==currentCar){
							if(!controls.enabled) {
								carController.update(timeDelta);



							cameraController.update(pos_x,pos_z);
							gui.options.updatecamera();

						//	camera.position.x =+ (CARS[currentCar].position.x);
						//	camera.position.z =+ (CARS[currentCar].position.z - 400);


								if(cameraController.getCurrentCamera().startsWith("birdseye")) camera.rotation.set(-0.5 * Math.PI, 0.0, -Math.PI)
								else if(cameraController.getCurrentCamera() !== 'dashCam') camera.lookAt(CARS[currentCar].position)
								else camera.lookAt(CARS[currentCar].object.localToWorld(new THREE.Vector3( 0, 0, 500) )  )
							}
						}
					}
				}

				if(!controls.enabled) {
					if(typeof CARS == 'undefined' || Object.keys(CARS).length === undefined || CARS.length == 0) camera.lookAt(new THREE.Vector3( 90000,  50, 72000));
				}

				if(rainController.isItRaining()) {
					rainController.simulateRain();
				}

				if (useStereo) {
					effect.render( scene, camera );
				}
				else {
					renderer.render(scene, camera);
				}

				if ( STATS_ENABLED ) stats.update();

			}

			function updateCarPose(x,y,z,theta)
			{
				currentCarObj = CARS[currentCar].object;

				currentCarObj.position.x += x;
				currentCarObj.position.y += y;
				currentCarObj.position.z += z;

				currentCarObj.rotateX(theta.x);
				currentCarObj.rotateY(theta.y);
				currentCarObj.rotateZ(theta.z);

        		renderer.render(scene, camera)

				cameraController.updateRelativeCameraPosition();
			}

</script>
</body>
</html>
